// Copyright (C) 2022 RozK
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef _RK_ENGINE_TYPES_H
#define _RK_ENGINE_TYPES_H

#include <cstdbool>
#include <cstdint>

#define RK_EXPORT extern "C"
#define RK_FLAG(_bit) (1 << (_bit))

typedef bool rk_bool;
typedef char rk_char;
typedef wchar_t rk_wchar;
typedef int8_t rk_byte;
typedef uint8_t rk_ubyte;
typedef int16_t rk_short;
typedef uint16_t rk_ushort;
typedef int32_t rk_int;
typedef uint32_t rk_uint;
typedef int64_t rk_long;
typedef uint64_t rk_ulong;

typedef void * rk_handle_t;

#define RK_INVALID_HANDLE nullptr

#endif // _RK_ENGINE_TYPES_H
